// Code generated by ent, DO NOT EDIT.

package ent

import (
	"context"
	"fmt"
	"math"

	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
	"entgo.io/ent/schema/field"
	"github.com/google/uuid"
	"gitlab.com/pajaziti.bersen/agorus-ent/ent/item"
	"gitlab.com/pajaziti.bersen/agorus-ent/ent/itemmeta"
	"gitlab.com/pajaziti.bersen/agorus-ent/ent/predicate"
)

// ItemMetaQuery is the builder for querying ItemMeta entities.
type ItemMetaQuery struct {
	config
	limit      *int
	offset     *int
	unique     *bool
	order      []OrderFunc
	fields     []string
	predicates []predicate.ItemMeta
	// eager-loading edges.
	withItem *ItemQuery
	// intermediate query (i.e. traversal path).
	sql  *sql.Selector
	path func(context.Context) (*sql.Selector, error)
}

// Where adds a new predicate for the ItemMetaQuery builder.
func (imq *ItemMetaQuery) Where(ps ...predicate.ItemMeta) *ItemMetaQuery {
	imq.predicates = append(imq.predicates, ps...)
	return imq
}

// Limit adds a limit step to the query.
func (imq *ItemMetaQuery) Limit(limit int) *ItemMetaQuery {
	imq.limit = &limit
	return imq
}

// Offset adds an offset step to the query.
func (imq *ItemMetaQuery) Offset(offset int) *ItemMetaQuery {
	imq.offset = &offset
	return imq
}

// Unique configures the query builder to filter duplicate records on query.
// By default, unique is set to true, and can be disabled using this method.
func (imq *ItemMetaQuery) Unique(unique bool) *ItemMetaQuery {
	imq.unique = &unique
	return imq
}

// Order adds an order step to the query.
func (imq *ItemMetaQuery) Order(o ...OrderFunc) *ItemMetaQuery {
	imq.order = append(imq.order, o...)
	return imq
}

// QueryItem chains the current query on the "item" edge.
func (imq *ItemMetaQuery) QueryItem() *ItemQuery {
	query := &ItemQuery{config: imq.config}
	query.path = func(ctx context.Context) (fromU *sql.Selector, err error) {
		if err := imq.prepareQuery(ctx); err != nil {
			return nil, err
		}
		selector := imq.sqlQuery(ctx)
		if err := selector.Err(); err != nil {
			return nil, err
		}
		step := sqlgraph.NewStep(
			sqlgraph.From(itemmeta.Table, itemmeta.FieldID, selector),
			sqlgraph.To(item.Table, item.FieldID),
			sqlgraph.Edge(sqlgraph.M2O, true, itemmeta.ItemTable, itemmeta.ItemColumn),
		)
		fromU = sqlgraph.SetNeighbors(imq.driver.Dialect(), step)
		return fromU, nil
	}
	return query
}

// First returns the first ItemMeta entity from the query.
// Returns a *NotFoundError when no ItemMeta was found.
func (imq *ItemMetaQuery) First(ctx context.Context) (*ItemMeta, error) {
	nodes, err := imq.Limit(1).All(ctx)
	if err != nil {
		return nil, err
	}
	if len(nodes) == 0 {
		return nil, &NotFoundError{itemmeta.Label}
	}
	return nodes[0], nil
}

// FirstX is like First, but panics if an error occurs.
func (imq *ItemMetaQuery) FirstX(ctx context.Context) *ItemMeta {
	node, err := imq.First(ctx)
	if err != nil && !IsNotFound(err) {
		panic(err)
	}
	return node
}

// FirstID returns the first ItemMeta ID from the query.
// Returns a *NotFoundError when no ItemMeta ID was found.
func (imq *ItemMetaQuery) FirstID(ctx context.Context) (id uuid.UUID, err error) {
	var ids []uuid.UUID
	if ids, err = imq.Limit(1).IDs(ctx); err != nil {
		return
	}
	if len(ids) == 0 {
		err = &NotFoundError{itemmeta.Label}
		return
	}
	return ids[0], nil
}

// FirstIDX is like FirstID, but panics if an error occurs.
func (imq *ItemMetaQuery) FirstIDX(ctx context.Context) uuid.UUID {
	id, err := imq.FirstID(ctx)
	if err != nil && !IsNotFound(err) {
		panic(err)
	}
	return id
}

// Only returns a single ItemMeta entity found by the query, ensuring it only returns one.
// Returns a *NotSingularError when more than one ItemMeta entity is found.
// Returns a *NotFoundError when no ItemMeta entities are found.
func (imq *ItemMetaQuery) Only(ctx context.Context) (*ItemMeta, error) {
	nodes, err := imq.Limit(2).All(ctx)
	if err != nil {
		return nil, err
	}
	switch len(nodes) {
	case 1:
		return nodes[0], nil
	case 0:
		return nil, &NotFoundError{itemmeta.Label}
	default:
		return nil, &NotSingularError{itemmeta.Label}
	}
}

// OnlyX is like Only, but panics if an error occurs.
func (imq *ItemMetaQuery) OnlyX(ctx context.Context) *ItemMeta {
	node, err := imq.Only(ctx)
	if err != nil {
		panic(err)
	}
	return node
}

// OnlyID is like Only, but returns the only ItemMeta ID in the query.
// Returns a *NotSingularError when more than one ItemMeta ID is found.
// Returns a *NotFoundError when no entities are found.
func (imq *ItemMetaQuery) OnlyID(ctx context.Context) (id uuid.UUID, err error) {
	var ids []uuid.UUID
	if ids, err = imq.Limit(2).IDs(ctx); err != nil {
		return
	}
	switch len(ids) {
	case 1:
		id = ids[0]
	case 0:
		err = &NotFoundError{itemmeta.Label}
	default:
		err = &NotSingularError{itemmeta.Label}
	}
	return
}

// OnlyIDX is like OnlyID, but panics if an error occurs.
func (imq *ItemMetaQuery) OnlyIDX(ctx context.Context) uuid.UUID {
	id, err := imq.OnlyID(ctx)
	if err != nil {
		panic(err)
	}
	return id
}

// All executes the query and returns a list of ItemMetaSlice.
func (imq *ItemMetaQuery) All(ctx context.Context) ([]*ItemMeta, error) {
	if err := imq.prepareQuery(ctx); err != nil {
		return nil, err
	}
	return imq.sqlAll(ctx)
}

// AllX is like All, but panics if an error occurs.
func (imq *ItemMetaQuery) AllX(ctx context.Context) []*ItemMeta {
	nodes, err := imq.All(ctx)
	if err != nil {
		panic(err)
	}
	return nodes
}

// IDs executes the query and returns a list of ItemMeta IDs.
func (imq *ItemMetaQuery) IDs(ctx context.Context) ([]uuid.UUID, error) {
	var ids []uuid.UUID
	if err := imq.Select(itemmeta.FieldID).Scan(ctx, &ids); err != nil {
		return nil, err
	}
	return ids, nil
}

// IDsX is like IDs, but panics if an error occurs.
func (imq *ItemMetaQuery) IDsX(ctx context.Context) []uuid.UUID {
	ids, err := imq.IDs(ctx)
	if err != nil {
		panic(err)
	}
	return ids
}

// Count returns the count of the given query.
func (imq *ItemMetaQuery) Count(ctx context.Context) (int, error) {
	if err := imq.prepareQuery(ctx); err != nil {
		return 0, err
	}
	return imq.sqlCount(ctx)
}

// CountX is like Count, but panics if an error occurs.
func (imq *ItemMetaQuery) CountX(ctx context.Context) int {
	count, err := imq.Count(ctx)
	if err != nil {
		panic(err)
	}
	return count
}

// Exist returns true if the query has elements in the graph.
func (imq *ItemMetaQuery) Exist(ctx context.Context) (bool, error) {
	if err := imq.prepareQuery(ctx); err != nil {
		return false, err
	}
	return imq.sqlExist(ctx)
}

// ExistX is like Exist, but panics if an error occurs.
func (imq *ItemMetaQuery) ExistX(ctx context.Context) bool {
	exist, err := imq.Exist(ctx)
	if err != nil {
		panic(err)
	}
	return exist
}

// Clone returns a duplicate of the ItemMetaQuery builder, including all associated steps. It can be
// used to prepare common query builders and use them differently after the clone is made.
func (imq *ItemMetaQuery) Clone() *ItemMetaQuery {
	if imq == nil {
		return nil
	}
	return &ItemMetaQuery{
		config:     imq.config,
		limit:      imq.limit,
		offset:     imq.offset,
		order:      append([]OrderFunc{}, imq.order...),
		predicates: append([]predicate.ItemMeta{}, imq.predicates...),
		withItem:   imq.withItem.Clone(),
		// clone intermediate query.
		sql:    imq.sql.Clone(),
		path:   imq.path,
		unique: imq.unique,
	}
}

// WithItem tells the query-builder to eager-load the nodes that are connected to
// the "item" edge. The optional arguments are used to configure the query builder of the edge.
func (imq *ItemMetaQuery) WithItem(opts ...func(*ItemQuery)) *ItemMetaQuery {
	query := &ItemQuery{config: imq.config}
	for _, opt := range opts {
		opt(query)
	}
	imq.withItem = query
	return imq
}

// GroupBy is used to group vertices by one or more fields/columns.
// It is often used with aggregate functions, like: count, max, mean, min, sum.
//
// Example:
//
//	var v []struct {
//		Key string `json:"key,omitempty"`
//		Count int `json:"count,omitempty"`
//	}
//
//	client.ItemMeta.Query().
//		GroupBy(itemmeta.FieldKey).
//		Aggregate(ent.Count()).
//		Scan(ctx, &v)
func (imq *ItemMetaQuery) GroupBy(field string, fields ...string) *ItemMetaGroupBy {
	grbuild := &ItemMetaGroupBy{config: imq.config}
	grbuild.fields = append([]string{field}, fields...)
	grbuild.path = func(ctx context.Context) (prev *sql.Selector, err error) {
		if err := imq.prepareQuery(ctx); err != nil {
			return nil, err
		}
		return imq.sqlQuery(ctx), nil
	}
	grbuild.label = itemmeta.Label
	grbuild.flds, grbuild.scan = &grbuild.fields, grbuild.Scan
	return grbuild
}

// Select allows the selection one or more fields/columns for the given query,
// instead of selecting all fields in the entity.
//
// Example:
//
//	var v []struct {
//		Key string `json:"key,omitempty"`
//	}
//
//	client.ItemMeta.Query().
//		Select(itemmeta.FieldKey).
//		Scan(ctx, &v)
func (imq *ItemMetaQuery) Select(fields ...string) *ItemMetaSelect {
	imq.fields = append(imq.fields, fields...)
	selbuild := &ItemMetaSelect{ItemMetaQuery: imq}
	selbuild.label = itemmeta.Label
	selbuild.flds, selbuild.scan = &imq.fields, selbuild.Scan
	return selbuild
}

func (imq *ItemMetaQuery) prepareQuery(ctx context.Context) error {
	for _, f := range imq.fields {
		if !itemmeta.ValidColumn(f) {
			return &ValidationError{Name: f, err: fmt.Errorf("ent: invalid field %q for query", f)}
		}
	}
	if imq.path != nil {
		prev, err := imq.path(ctx)
		if err != nil {
			return err
		}
		imq.sql = prev
	}
	return nil
}

func (imq *ItemMetaQuery) sqlAll(ctx context.Context, hooks ...queryHook) ([]*ItemMeta, error) {
	var (
		nodes       = []*ItemMeta{}
		_spec       = imq.querySpec()
		loadedTypes = [1]bool{
			imq.withItem != nil,
		}
	)
	_spec.ScanValues = func(columns []string) ([]interface{}, error) {
		return (*ItemMeta).scanValues(nil, columns)
	}
	_spec.Assign = func(columns []string, values []interface{}) error {
		node := &ItemMeta{config: imq.config}
		nodes = append(nodes, node)
		node.Edges.loadedTypes = loadedTypes
		return node.assignValues(columns, values)
	}
	for i := range hooks {
		hooks[i](ctx, _spec)
	}
	if err := sqlgraph.QueryNodes(ctx, imq.driver, _spec); err != nil {
		return nil, err
	}
	if len(nodes) == 0 {
		return nodes, nil
	}

	if query := imq.withItem; query != nil {
		ids := make([]uuid.UUID, 0, len(nodes))
		nodeids := make(map[uuid.UUID][]*ItemMeta)
		for i := range nodes {
			fk := nodes[i].ItemID
			if _, ok := nodeids[fk]; !ok {
				ids = append(ids, fk)
			}
			nodeids[fk] = append(nodeids[fk], nodes[i])
		}
		query.Where(item.IDIn(ids...))
		neighbors, err := query.All(ctx)
		if err != nil {
			return nil, err
		}
		for _, n := range neighbors {
			nodes, ok := nodeids[n.ID]
			if !ok {
				return nil, fmt.Errorf(`unexpected foreign-key "item_id" returned %v`, n.ID)
			}
			for i := range nodes {
				nodes[i].Edges.Item = n
			}
		}
	}

	return nodes, nil
}

func (imq *ItemMetaQuery) sqlCount(ctx context.Context) (int, error) {
	_spec := imq.querySpec()
	_spec.Node.Columns = imq.fields
	if len(imq.fields) > 0 {
		_spec.Unique = imq.unique != nil && *imq.unique
	}
	return sqlgraph.CountNodes(ctx, imq.driver, _spec)
}

func (imq *ItemMetaQuery) sqlExist(ctx context.Context) (bool, error) {
	n, err := imq.sqlCount(ctx)
	if err != nil {
		return false, fmt.Errorf("ent: check existence: %w", err)
	}
	return n > 0, nil
}

func (imq *ItemMetaQuery) querySpec() *sqlgraph.QuerySpec {
	_spec := &sqlgraph.QuerySpec{
		Node: &sqlgraph.NodeSpec{
			Table:   itemmeta.Table,
			Columns: itemmeta.Columns,
			ID: &sqlgraph.FieldSpec{
				Type:   field.TypeUUID,
				Column: itemmeta.FieldID,
			},
		},
		From:   imq.sql,
		Unique: true,
	}
	if unique := imq.unique; unique != nil {
		_spec.Unique = *unique
	}
	if fields := imq.fields; len(fields) > 0 {
		_spec.Node.Columns = make([]string, 0, len(fields))
		_spec.Node.Columns = append(_spec.Node.Columns, itemmeta.FieldID)
		for i := range fields {
			if fields[i] != itemmeta.FieldID {
				_spec.Node.Columns = append(_spec.Node.Columns, fields[i])
			}
		}
	}
	if ps := imq.predicates; len(ps) > 0 {
		_spec.Predicate = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	if limit := imq.limit; limit != nil {
		_spec.Limit = *limit
	}
	if offset := imq.offset; offset != nil {
		_spec.Offset = *offset
	}
	if ps := imq.order; len(ps) > 0 {
		_spec.Order = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	return _spec
}

func (imq *ItemMetaQuery) sqlQuery(ctx context.Context) *sql.Selector {
	builder := sql.Dialect(imq.driver.Dialect())
	t1 := builder.Table(itemmeta.Table)
	columns := imq.fields
	if len(columns) == 0 {
		columns = itemmeta.Columns
	}
	selector := builder.Select(t1.Columns(columns...)...).From(t1)
	if imq.sql != nil {
		selector = imq.sql
		selector.Select(selector.Columns(columns...)...)
	}
	if imq.unique != nil && *imq.unique {
		selector.Distinct()
	}
	for _, p := range imq.predicates {
		p(selector)
	}
	for _, p := range imq.order {
		p(selector)
	}
	if offset := imq.offset; offset != nil {
		// limit is mandatory for offset clause. We start
		// with default value, and override it below if needed.
		selector.Offset(*offset).Limit(math.MaxInt32)
	}
	if limit := imq.limit; limit != nil {
		selector.Limit(*limit)
	}
	return selector
}

// ItemMetaGroupBy is the group-by builder for ItemMeta entities.
type ItemMetaGroupBy struct {
	config
	selector
	fields []string
	fns    []AggregateFunc
	// intermediate query (i.e. traversal path).
	sql  *sql.Selector
	path func(context.Context) (*sql.Selector, error)
}

// Aggregate adds the given aggregation functions to the group-by query.
func (imgb *ItemMetaGroupBy) Aggregate(fns ...AggregateFunc) *ItemMetaGroupBy {
	imgb.fns = append(imgb.fns, fns...)
	return imgb
}

// Scan applies the group-by query and scans the result into the given value.
func (imgb *ItemMetaGroupBy) Scan(ctx context.Context, v interface{}) error {
	query, err := imgb.path(ctx)
	if err != nil {
		return err
	}
	imgb.sql = query
	return imgb.sqlScan(ctx, v)
}

func (imgb *ItemMetaGroupBy) sqlScan(ctx context.Context, v interface{}) error {
	for _, f := range imgb.fields {
		if !itemmeta.ValidColumn(f) {
			return &ValidationError{Name: f, err: fmt.Errorf("invalid field %q for group-by", f)}
		}
	}
	selector := imgb.sqlQuery()
	if err := selector.Err(); err != nil {
		return err
	}
	rows := &sql.Rows{}
	query, args := selector.Query()
	if err := imgb.driver.Query(ctx, query, args, rows); err != nil {
		return err
	}
	defer rows.Close()
	return sql.ScanSlice(rows, v)
}

func (imgb *ItemMetaGroupBy) sqlQuery() *sql.Selector {
	selector := imgb.sql.Select()
	aggregation := make([]string, 0, len(imgb.fns))
	for _, fn := range imgb.fns {
		aggregation = append(aggregation, fn(selector))
	}
	// If no columns were selected in a custom aggregation function, the default
	// selection is the fields used for "group-by", and the aggregation functions.
	if len(selector.SelectedColumns()) == 0 {
		columns := make([]string, 0, len(imgb.fields)+len(imgb.fns))
		for _, f := range imgb.fields {
			columns = append(columns, selector.C(f))
		}
		columns = append(columns, aggregation...)
		selector.Select(columns...)
	}
	return selector.GroupBy(selector.Columns(imgb.fields...)...)
}

// ItemMetaSelect is the builder for selecting fields of ItemMeta entities.
type ItemMetaSelect struct {
	*ItemMetaQuery
	selector
	// intermediate query (i.e. traversal path).
	sql *sql.Selector
}

// Scan applies the selector query and scans the result into the given value.
func (ims *ItemMetaSelect) Scan(ctx context.Context, v interface{}) error {
	if err := ims.prepareQuery(ctx); err != nil {
		return err
	}
	ims.sql = ims.ItemMetaQuery.sqlQuery(ctx)
	return ims.sqlScan(ctx, v)
}

func (ims *ItemMetaSelect) sqlScan(ctx context.Context, v interface{}) error {
	rows := &sql.Rows{}
	query, args := ims.sql.Query()
	if err := ims.driver.Query(ctx, query, args, rows); err != nil {
		return err
	}
	defer rows.Close()
	return sql.ScanSlice(rows, v)
}
